<script setup lang="ts">
import { useISAStore } from '@/stores/useISAStore';
import { onMounted, onUnmounted } from 'vue';

const ISAStore = useISAStore()
let timer = null

onMounted(() => {
    setInterval(async () => {
        await ISAStore.saveAndRefresh()
    }, 20000)
})

onUnmounted(() => {
    if(timer) {
        clearInterval(timer)
    }
})

function editInvestigation(iid: number|null) {
    if(iid != null) {
        navigateTo('/investigations/'+iid)
    } else {
        navigateTo('/investigations/new')
    }
}

function openInvestigation(investigation) {
    investigation.opened = investigation?.opened ? false : true
    if(investigation.opened) {
        ISAStore.fetchStudies(investigation.id)
    }
}

function openStudy(investigation, study) {
    study.opened = study.opened ? false : true
    if(study.opened) {
        ISAStore.fetchAssays(investigation.id, study.id)
    }
}

function editStudy(iid: number|null, sid: number|null) {
    if(iid != null && sid != null) {
        navigateTo('/investigations/i'+iid+'/studies/'+sid)
    }
}

function editAssay(iid: number|null, sid: number|null, aid: number|null) {
    if(iid != null && sid != null && aid != null) {
        navigateTo('/investigations/i'+iid+'/studies/s'+sid+'/assays/'+aid)
    }
}
</script>

<template>
<div>
    <!-- <NuxtLink to="/">Home</NuxtLink> -->
    <div v-for="investigation in ISAStore.investigations.values()">
        <InvestigationItem
            :investigation="investigation"
            :active="investigation.id == ISAStore.currentIid"
            @open="openInvestigation(investigation)"
            @choose="editInvestigation(investigation.id)"
        />
        <div v-if="investigation.opened" v-for="study in investigation.studies.values()">
            <StudyItem
                :active="investigation.id == ISAStore.currentSid?.iid && study.id == ISAStore.currentSid?.sid"
                :study="study"
                @open="openStudy(investigation, study)"
                @choose="editStudy(investigation.id, study.id)"
            />
            <AssayItem
                v-if="study.opened"
                v-for="assay in study.assays.values()"
                :active="investigation.id == ISAStore.currentAid?.iid && study.id == ISAStore.currentAid?.sid && assay.id == ISAStore.currentAid?.aid"
                :assay="assay"
                @choose="editAssay(investigation.id, study.id, assay.id)"/>
        </div>
    </div>
    <!-- <v-list density="compact" class="pa-0 transparent" v-model:opened="ISAStore.openedInvestigations">
        <v-list-subheader>INVESTIGATIONS</v-list-subheader>
        <v-list-group v-for="investigation in ISAStore.investigations" :value="investigation.id">
            <template v-slot:activator="{ props }">
                <v-list-item
                    v-bind="props"
                    preprend-icon="mdi-lightbulb-on-outline"
                    :title="investigation.name ? investigation.name : 'No name'"
                    :active="investigation.id == ISAStore.currentId"
                    @click="editInvestigation(investigation.id)"
                ></v-list-item>
            </template>

            <v-list-item
                v-for="study in investigation.studies.values()"
                :title="study.name ? study.name : 'No name'"
                prepend-icon="mdi-notebook-outline"
                :value="study.id"
                @click="editStudy(study.id)"
            ></v-list-item>

        </v-list-group>
    </v-list> -->
</div>
</template>

<style>
.transparent {
  background: transparent
}
</style>
